/*
 * Created on 2019-09-10 ( Time 09:02:06 )
 * Generated by Telosys Tools Generator ( version 3.0.0 )
 */
// This Bean has a basic Primary Key (not composite) 

package ci.diaspora.star.motors.sarl.dao.entity;

import java.io.Serializable;

//import javax.validation.constraints.* ;
//import org.hibernate.validator.constraints.* ;

import java.util.Date;
import java.util.List;

import javax.persistence.*;

/**
 * Persistent class for entity stored in table "vehicule"
 *
 * @author Telosys Tools Generator
 *
 */

@Entity
@Table(name="vehicule" )
public class Vehicule implements Serializable, Cloneable {

    private static final long serialVersionUID = 1L;

    //----------------------------------------------------------------------
    // ENTITY PRIMARY KEY ( BASED ON A SINGLE FIELD )
    //----------------------------------------------------------------------
	/*
	 * 
	 */
    @Id
    @GeneratedValue(strategy=GenerationType.AUTO)
    @Column(name="id", nullable=false)
    private Integer    id           ;


    //----------------------------------------------------------------------
    // ENTITY DATA FIELDS 
    //----------------------------------------------------------------------    
	/*
	 * 
	 */
    @Column(name="immatriculation", length=255)
    private String     immatriculation ;

	/*
	 * 
	 */
    @Column(name="numero_chassis", length=255)
    private String     numeroChassis ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="date_prochaine_revision")
    private Date       dateProchaineRevision ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="date_visite_technique")
    private Date       dateVisiteTechnique ;

	/*
	 * 
	 */
    @Column(name="is_deleted")
    private Boolean    isDeleted    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="created_at")
    private Date       createdAt    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="updated_at")
    private Date       updatedAt    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="deleted_at")
    private Date       deletedAt    ;

	/*
	 * 
	 */
    @Column(name="created_by")
    private Integer    createdBy    ;

	/*
	 * 
	 */
    @Column(name="updated_by")
    private Integer    updatedBy    ;

	/*
	 * 
	 */
    @Column(name="deleted_by")
    private Integer    deletedBy    ;

	// "clientId" (column "client_id") is not defined by itself because used as FK in a link 
	// "typeId" (column "type_id") is not defined by itself because used as FK in a link 
	// "marqueId" (column "marque_id") is not defined by itself because used as FK in a link 
	// "energieId" (column "energie_id") is not defined by itself because used as FK in a link 
	// "couleurVehiculeId" (column "couleur_vehicule_id") is not defined by itself because used as FK in a link 


    //----------------------------------------------------------------------
    // ENTITY LINKS ( RELATIONSHIP )
    //----------------------------------------------------------------------
    @ManyToOne
    @JoinColumn(name="type_id", referencedColumnName="id")
    private TypeVehicule typeVehicule;
    @ManyToOne
    @JoinColumn(name="client_id", referencedColumnName="id")
    private Client client      ;
    @ManyToOne
    @JoinColumn(name="marque_id", referencedColumnName="id")
    private Marque marque      ;
    @ManyToOne
    @JoinColumn(name="couleur_vehicule_id", referencedColumnName="id")
    private CouleurVehicule couleurVehicule;
    @ManyToOne
    @JoinColumn(name="energie_id", referencedColumnName="id")
    private EnergieVehicule energieVehicule;

    //----------------------------------------------------------------------
    // CONSTRUCTOR(S)
    //----------------------------------------------------------------------
    public Vehicule() {
		super();
    }
    
    //----------------------------------------------------------------------
    // GETTER & SETTER FOR THE KEY FIELD
    //----------------------------------------------------------------------
    public void setId( Integer id ) {
        this.id = id ;
    }
    public Integer getId() {
        return this.id;
    }

    //----------------------------------------------------------------------
    // GETTERS & SETTERS FOR FIELDS
    //----------------------------------------------------------------------
    //--- DATABASE MAPPING : immatriculation ( VARCHAR ) 
    public void setImmatriculation( String immatriculation ) {
        this.immatriculation = immatriculation;
    }
    public String getImmatriculation() {
        return this.immatriculation;
    }

    //--- DATABASE MAPPING : numero_chassis ( VARCHAR ) 
    public void setNumeroChassis( String numeroChassis ) {
        this.numeroChassis = numeroChassis;
    }
    public String getNumeroChassis() {
        return this.numeroChassis;
    }

    //--- DATABASE MAPPING : date_prochaine_revision ( DATETIME ) 
    public void setDateProchaineRevision( Date dateProchaineRevision ) {
        this.dateProchaineRevision = dateProchaineRevision;
    }
    public Date getDateProchaineRevision() {
        return this.dateProchaineRevision;
    }

    //--- DATABASE MAPPING : date_visite_technique ( DATETIME ) 
    public void setDateVisiteTechnique( Date dateVisiteTechnique ) {
        this.dateVisiteTechnique = dateVisiteTechnique;
    }
    public Date getDateVisiteTechnique() {
        return this.dateVisiteTechnique;
    }

    //--- DATABASE MAPPING : is_deleted ( BIT ) 
    public void setIsDeleted( Boolean isDeleted ) {
        this.isDeleted = isDeleted;
    }
    public Boolean getIsDeleted() {
        return this.isDeleted;
    }

    //--- DATABASE MAPPING : created_at ( DATETIME ) 
    public void setCreatedAt( Date createdAt ) {
        this.createdAt = createdAt;
    }
    public Date getCreatedAt() {
        return this.createdAt;
    }

    //--- DATABASE MAPPING : updated_at ( DATETIME ) 
    public void setUpdatedAt( Date updatedAt ) {
        this.updatedAt = updatedAt;
    }
    public Date getUpdatedAt() {
        return this.updatedAt;
    }

    //--- DATABASE MAPPING : deleted_at ( DATETIME ) 
    public void setDeletedAt( Date deletedAt ) {
        this.deletedAt = deletedAt;
    }
    public Date getDeletedAt() {
        return this.deletedAt;
    }

    //--- DATABASE MAPPING : created_by ( INT ) 
    public void setCreatedBy( Integer createdBy ) {
        this.createdBy = createdBy;
    }
    public Integer getCreatedBy() {
        return this.createdBy;
    }

    //--- DATABASE MAPPING : updated_by ( INT ) 
    public void setUpdatedBy( Integer updatedBy ) {
        this.updatedBy = updatedBy;
    }
    public Integer getUpdatedBy() {
        return this.updatedBy;
    }

    //--- DATABASE MAPPING : deleted_by ( INT ) 
    public void setDeletedBy( Integer deletedBy ) {
        this.deletedBy = deletedBy;
    }
    public Integer getDeletedBy() {
        return this.deletedBy;
    }


    //----------------------------------------------------------------------
    // GETTERS & SETTERS FOR LINKS
    //----------------------------------------------------------------------

    public void setTypeVehicule( TypeVehicule typeVehicule ) {
        this.typeVehicule = typeVehicule;
    }
    public TypeVehicule getTypeVehicule() {
        return this.typeVehicule;
    }


    public void setClient( Client client ) {
        this.client = client;
    }
    public Client getClient() {
        return this.client;
    }


    public void setMarque( Marque marque ) {
        this.marque = marque;
    }
    public Marque getMarque() {
        return this.marque;
    }


    public void setCouleurVehicule( CouleurVehicule couleurVehicule ) {
        this.couleurVehicule = couleurVehicule;
    }
    public CouleurVehicule getCouleurVehicule() {
        return this.couleurVehicule;
    }


    public void setEnergieVehicule( EnergieVehicule energieVehicule ) {
        this.energieVehicule = energieVehicule;
    }
    public EnergieVehicule getEnergieVehicule() {
        return this.energieVehicule;
    }


    //----------------------------------------------------------------------
    // toString METHOD
    //----------------------------------------------------------------------
    public String toString() { 
        StringBuffer sb = new StringBuffer(); 
        sb.append("["); 
        sb.append(id);
        sb.append("]:"); 
        sb.append(immatriculation);
        sb.append("|");
        sb.append(numeroChassis);
        sb.append("|");
        sb.append(dateProchaineRevision);
        sb.append("|");
        sb.append(dateVisiteTechnique);
        sb.append("|");
        sb.append(isDeleted);
        sb.append("|");
        sb.append(createdAt);
        sb.append("|");
        sb.append(updatedAt);
        sb.append("|");
        sb.append(deletedAt);
        sb.append("|");
        sb.append(createdBy);
        sb.append("|");
        sb.append(updatedBy);
        sb.append("|");
        sb.append(deletedBy);
        return sb.toString(); 
    } 

	//----------------------------------------------------------------------
    // clone METHOD
    //----------------------------------------------------------------------
	@Override
	public Object clone() throws CloneNotSupportedException {
		return super.clone();
	}
}
